<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCariSevkAdresi ArrayType
 * @subpackage Arrays
 */
class ArrayOfCariSevkAdresi extends AbstractStructArrayBase
{
    /**
     * The CariSevkAdresi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CariSevkAdresi[]
     */
    public $CariSevkAdresi;
    /**
     * Constructor method for ArrayOfCariSevkAdresi
     * @uses ArrayOfCariSevkAdresi::setCariSevkAdresi()
     * @param \StructType\CariSevkAdresi[] $cariSevkAdresi
     */
    public function __construct(array $cariSevkAdresi = array())
    {
        $this
            ->setCariSevkAdresi($cariSevkAdresi);
    }
    /**
     * Get CariSevkAdresi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CariSevkAdresi[]|null
     */
    public function getCariSevkAdresi()
    {
        return isset($this->CariSevkAdresi) ? $this->CariSevkAdresi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCariSevkAdresi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCariSevkAdresi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCariSevkAdresiForArrayConstraintsFromSetCariSevkAdresi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCariSevkAdresiCariSevkAdresiItem) {
            // validation for constraint: itemType
            if (!$arrayOfCariSevkAdresiCariSevkAdresiItem instanceof \StructType\CariSevkAdresi) {
                $invalidValues[] = is_object($arrayOfCariSevkAdresiCariSevkAdresiItem) ? get_class($arrayOfCariSevkAdresiCariSevkAdresiItem) : sprintf('%s(%s)', gettype($arrayOfCariSevkAdresiCariSevkAdresiItem), var_export($arrayOfCariSevkAdresiCariSevkAdresiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CariSevkAdresi property can only contain items of type \StructType\CariSevkAdresi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CariSevkAdresi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CariSevkAdresi[] $cariSevkAdresi
     * @return \ArrayType\ArrayOfCariSevkAdresi
     */
    public function setCariSevkAdresi(array $cariSevkAdresi = array())
    {
        // validation for constraint: array
        if ('' !== ($cariSevkAdresiArrayErrorMessage = self::validateCariSevkAdresiForArrayConstraintsFromSetCariSevkAdresi($cariSevkAdresi))) {
            throw new \InvalidArgumentException($cariSevkAdresiArrayErrorMessage, __LINE__);
        }
        if (is_null($cariSevkAdresi) || (is_array($cariSevkAdresi) && empty($cariSevkAdresi))) {
            unset($this->CariSevkAdresi);
        } else {
            $this->CariSevkAdresi = $cariSevkAdresi;
        }
        return $this;
    }
    /**
     * Add item to CariSevkAdresi value
     * @throws \InvalidArgumentException
     * @param \StructType\CariSevkAdresi $item
     * @return \ArrayType\ArrayOfCariSevkAdresi
     */
    public function addToCariSevkAdresi(\StructType\CariSevkAdresi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CariSevkAdresi) {
            throw new \InvalidArgumentException(sprintf('The CariSevkAdresi property can only contain items of type \StructType\CariSevkAdresi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CariSevkAdresi[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CariSevkAdresi|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CariSevkAdresi|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CariSevkAdresi|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CariSevkAdresi|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CariSevkAdresi|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CariSevkAdresi
     */
    public function getAttributeName()
    {
        return 'CariSevkAdresi';
    }
}
