<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MuhasebelestirmeGrubu StructType
 * @subpackage Structs
 */
class MuhasebelestirmeGrubu extends SerendipEntity
{
    /**
     * The HesapGrubu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $HesapGrubu;
    /**
     * The Aciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Aciklama;
    /**
     * The MuhasebelestirmeHesapTipi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\MuhasebelestirmeHesapTipiPointer
     */
    public $MuhasebelestirmeHesapTipi;
    /**
     * Constructor method for MuhasebelestirmeGrubu
     * @uses MuhasebelestirmeGrubu::setHesapGrubu()
     * @uses MuhasebelestirmeGrubu::setAciklama()
     * @uses MuhasebelestirmeGrubu::setMuhasebelestirmeHesapTipi()
     * @param string $hesapGrubu
     * @param string $aciklama
     * @param \StructType\MuhasebelestirmeHesapTipiPointer $muhasebelestirmeHesapTipi
     */
    public function __construct($hesapGrubu = null, $aciklama = null, \StructType\MuhasebelestirmeHesapTipiPointer $muhasebelestirmeHesapTipi = null)
    {
        $this
            ->setHesapGrubu($hesapGrubu)
            ->setAciklama($aciklama)
            ->setMuhasebelestirmeHesapTipi($muhasebelestirmeHesapTipi);
    }
    /**
     * Get HesapGrubu value
     * @return string
     */
    public function getHesapGrubu()
    {
        return $this->HesapGrubu;
    }
    /**
     * Set HesapGrubu value
     * @uses \EnumType\MuhasebelestirmeHesapGrubu::valueIsValid()
     * @uses \EnumType\MuhasebelestirmeHesapGrubu::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $hesapGrubu
     * @return \StructType\MuhasebelestirmeGrubu
     */
    public function setHesapGrubu($hesapGrubu = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\MuhasebelestirmeHesapGrubu::valueIsValid($hesapGrubu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\MuhasebelestirmeHesapGrubu', is_array($hesapGrubu) ? implode(', ', $hesapGrubu) : var_export($hesapGrubu, true), implode(', ', \EnumType\MuhasebelestirmeHesapGrubu::getValidValues())), __LINE__);
        }
        $this->HesapGrubu = $hesapGrubu;
        return $this;
    }
    /**
     * Get Aciklama value
     * @return string|null
     */
    public function getAciklama()
    {
        return $this->Aciklama;
    }
    /**
     * Set Aciklama value
     * @param string $aciklama
     * @return \StructType\MuhasebelestirmeGrubu
     */
    public function setAciklama($aciklama = null)
    {
        // validation for constraint: string
        if (!is_null($aciklama) && !is_string($aciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aciklama, true), gettype($aciklama)), __LINE__);
        }
        $this->Aciklama = $aciklama;
        return $this;
    }
    /**
     * Get MuhasebelestirmeHesapTipi value
     * @return \StructType\MuhasebelestirmeHesapTipiPointer|null
     */
    public function getMuhasebelestirmeHesapTipi()
    {
        return $this->MuhasebelestirmeHesapTipi;
    }
    /**
     * Set MuhasebelestirmeHesapTipi value
     * @param \StructType\MuhasebelestirmeHesapTipiPointer $muhasebelestirmeHesapTipi
     * @return \StructType\MuhasebelestirmeGrubu
     */
    public function setMuhasebelestirmeHesapTipi(\StructType\MuhasebelestirmeHesapTipiPointer $muhasebelestirmeHesapTipi = null)
    {
        $this->MuhasebelestirmeHesapTipi = $muhasebelestirmeHesapTipi;
        return $this;
    }
}
