<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OdemePlaniSatiri StructType
 * @subpackage Structs
 */
class OdemePlaniSatiri extends SerendipEntity
{
    /**
     * The Gun
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Gun;
    /**
     * The Ay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Ay;
    /**
     * The Yil
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Yil;
    /**
     * The Formul
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Formul;
    /**
     * The Kosul
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kosul;
    /**
     * The OdemePlani
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OdemePlaniPointer
     */
    public $OdemePlani;
    /**
     * Constructor method for OdemePlaniSatiri
     * @uses OdemePlaniSatiri::setGun()
     * @uses OdemePlaniSatiri::setAy()
     * @uses OdemePlaniSatiri::setYil()
     * @uses OdemePlaniSatiri::setFormul()
     * @uses OdemePlaniSatiri::setKosul()
     * @uses OdemePlaniSatiri::setOdemePlani()
     * @param int $gun
     * @param int $ay
     * @param int $yil
     * @param string $formul
     * @param string $kosul
     * @param \StructType\OdemePlaniPointer $odemePlani
     */
    public function __construct($gun = null, $ay = null, $yil = null, $formul = null, $kosul = null, \StructType\OdemePlaniPointer $odemePlani = null)
    {
        $this
            ->setGun($gun)
            ->setAy($ay)
            ->setYil($yil)
            ->setFormul($formul)
            ->setKosul($kosul)
            ->setOdemePlani($odemePlani);
    }
    /**
     * Get Gun value
     * @return int
     */
    public function getGun()
    {
        return $this->Gun;
    }
    /**
     * Set Gun value
     * @param int $gun
     * @return \StructType\OdemePlaniSatiri
     */
    public function setGun($gun = null)
    {
        // validation for constraint: int
        if (!is_null($gun) && !(is_int($gun) || ctype_digit($gun))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($gun, true), gettype($gun)), __LINE__);
        }
        $this->Gun = $gun;
        return $this;
    }
    /**
     * Get Ay value
     * @return int
     */
    public function getAy()
    {
        return $this->Ay;
    }
    /**
     * Set Ay value
     * @param int $ay
     * @return \StructType\OdemePlaniSatiri
     */
    public function setAy($ay = null)
    {
        // validation for constraint: int
        if (!is_null($ay) && !(is_int($ay) || ctype_digit($ay))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ay, true), gettype($ay)), __LINE__);
        }
        $this->Ay = $ay;
        return $this;
    }
    /**
     * Get Yil value
     * @return int
     */
    public function getYil()
    {
        return $this->Yil;
    }
    /**
     * Set Yil value
     * @param int $yil
     * @return \StructType\OdemePlaniSatiri
     */
    public function setYil($yil = null)
    {
        // validation for constraint: int
        if (!is_null($yil) && !(is_int($yil) || ctype_digit($yil))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yil, true), gettype($yil)), __LINE__);
        }
        $this->Yil = $yil;
        return $this;
    }
    /**
     * Get Formul value
     * @return string|null
     */
    public function getFormul()
    {
        return $this->Formul;
    }
    /**
     * Set Formul value
     * @param string $formul
     * @return \StructType\OdemePlaniSatiri
     */
    public function setFormul($formul = null)
    {
        // validation for constraint: string
        if (!is_null($formul) && !is_string($formul)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($formul, true), gettype($formul)), __LINE__);
        }
        $this->Formul = $formul;
        return $this;
    }
    /**
     * Get Kosul value
     * @return string|null
     */
    public function getKosul()
    {
        return $this->Kosul;
    }
    /**
     * Set Kosul value
     * @param string $kosul
     * @return \StructType\OdemePlaniSatiri
     */
    public function setKosul($kosul = null)
    {
        // validation for constraint: string
        if (!is_null($kosul) && !is_string($kosul)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kosul, true), gettype($kosul)), __LINE__);
        }
        $this->Kosul = $kosul;
        return $this;
    }
    /**
     * Get OdemePlani value
     * @return \StructType\OdemePlaniPointer|null
     */
    public function getOdemePlani()
    {
        return $this->OdemePlani;
    }
    /**
     * Set OdemePlani value
     * @param \StructType\OdemePlaniPointer $odemePlani
     * @return \StructType\OdemePlaniSatiri
     */
    public function setOdemePlani(\StructType\OdemePlaniPointer $odemePlani = null)
    {
        $this->OdemePlani = $odemePlani;
        return $this;
    }
}
